package de.econda.example.hybrid;

import android.os.Bundle;
import android.webkit.WebView;
import android.webkit.WebViewClient;

import androidx.appcompat.app.AppCompatActivity;

import de.econda.droid.PageView;
import de.econda.droid.Session;
import de.econda.droid.hybrid.AndroidEmos;
import de.econda.example.MyApplication;
import de.econda.example.R;

public class WebViewActivity extends AppCompatActivity {

    /**
     * Storing the econdaAnalyticsSession in Activity for later reuse.
     */
    private Session econdaAnalyticsSession;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_web_view);

        // Get shared econdaAnalyticsSession from the Application and store it in private field for later reuse
        MyApplication application = (MyApplication) getApplication();
        econdaAnalyticsSession = application.getEcondaAnalyticsSession();

        WebView webView = (WebView) findViewById(R.id.webview);
        webView.setWebViewClient(new WebViewClient());

        webView.getSettings().setJavaScriptEnabled(true);

        AndroidEmos.addJavascriptInterfaceToWebView(webView, econdaAnalyticsSession, true);

        webView.loadUrl("http://replace-with-your-ip-address:8080/ExamplePageOnWebserver.html");


        sendPageView("WebViewActivity/Start");

    }

    private void sendPageView(String content) {

        PageView pageView = new PageView()
                .addContent(content);

        econdaAnalyticsSession.addPageView(pageView);

    }

}
