package de.econda.example.ui.main;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProviders;

import de.econda.droid.PrivacySettings;
import de.econda.droid.impl.Constants;
import de.econda.example.MainActivity;
import de.econda.example.R;
import de.econda.example.hybrid.WebViewActivity;

/**
 * A placeholder fragment containing a simple view.
 */
public class PlaceholderFragment extends Fragment {

    private static final String ARG_SECTION_NUMBER = "section_number";

    private PageViewModel pageViewModel;

    public PlaceholderFragment() {

    }

    public static PlaceholderFragment newInstance(int index) {
        PlaceholderFragment fragment = new PlaceholderFragment();
        Bundle bundle = new Bundle();
        bundle.putInt(ARG_SECTION_NUMBER, index);
        fragment.setArguments(bundle);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        pageViewModel = ViewModelProviders.of(this).get(PageViewModel.class);
        int index = 1;
        if (getArguments() != null) {
            index = getArguments().getInt(ARG_SECTION_NUMBER);
        }
        pageViewModel.setIndex(index);
    }

    @Override
    public View onCreateView(
            @NonNull LayoutInflater inflater, ViewGroup container,
            Bundle savedInstanceState) {
        View root = inflater.inflate(R.layout.fragment_main, container, false);
        final TextView textView = root.findViewById(R.id.section_label);
        pageViewModel.getText().observe(this, new Observer<String>() {
            @Override
            public void onChanged(@Nullable String s) {
                textView.setText(s);
            }
        });

        Button button = root.findViewById(R.id.button_to_webview);
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                MainActivity activity = (MainActivity) getActivity();
                activity.sendPageView("MainActivity/GoToWebViewButton");

                Intent intent = new Intent(activity, WebViewActivity.class);
                activity.startActivity(intent);
            }
        });

        Button button2 = root.findViewById(R.id.button_enable_full_tracking);
        button2.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                Log.d(Constants.LOG_TAG, "Full Visitor Tracking Button called");

                MainActivity activity = (MainActivity) getActivity();
                activity.getEcondaAnalyticsSession().changePrivacySettings(PrivacySettings.FULL);
            }
        });

        Button button3 = root.findViewById(R.id.button_enable_anonym_tracking);
        button3.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                Log.d(Constants.LOG_TAG, "Anonym Tracking Button called");

                MainActivity activity = (MainActivity) getActivity();
                activity.getEcondaAnalyticsSession().changePrivacySettings(PrivacySettings.ANONYM);
            }
        });



        return root;
    }
}